/**
 * Created with JetBrains AppCode.
 * User: eldargaliev
 * Date: 11/9/12
 * Time: 3:39 PM
 * To change this template use File | Settings | File Templates.
 */
window.FileSelector = {
  _fcTemplateId:'file-selector',
  $_fcTemplate:null,
  $_entryBrowserTpl:null,
  _options:{
    multi:false,
    uploadDestination:null,
    success:function (e) {
    },
    fail:function (e) {
    },
    chooseSuccess:function (entry) {
    },
    chooseFail:function (exc) {
    },
    chooseCancel:function () {
    },
    uploadSuccess:function (serverResponse) {
    },
    uploadFail:function (e) {
    }
  },

  open:function (options, type /* image, audio or video*/) {
      console.log('open');

      this._setup();
    var self = this;
    this._options = $.merge(this._options, options);
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
      function (fileSystem) {
          console.log('requestFileSystem: Success!');
        self._openExplorer(fileSystem.root, function(successArg){
          // todo success
        }, function(failErr){
          // todo error
        });
      },
      function (err) {
        self._options.fail(err);
        // todo something to handle error
      });
  },

  _setup:function () {
      console.log('setup');
    var self = this;
    this.$_fcTemplate = $(document.getElementById(this._fcTemplateId));
      console.log(this.$_fcTemplate.length);
    this.$_entryBrowserTpl = $(this.$_fcTemplate[0].getElementsByClassName('entry-browser-template')[0]);

    $(this.$_fcTemplate[0].querySelector('.file-view-format a')).click(function(){
        var $this = $(this);
        console.log($this.attr('class'));
        var $fileViewFormat = $(self.$_fcTemplate[0].getElementsByClassName('file-view-format')[0]);
        $($fileViewFormat[0].getElementsByClassName('ui-btn-active')).removeClass('ui-btn-active');
        $fileViewFormat.controlgroup('refresh');
        $(self.$_fcTemplate[0].querySelectorAll('.directory-entry .file-view')).removeClass('active');
        if($this.is('.as-grid')){
            $(self.$_fcTemplate[0].querySelector('.directory-entry .tiles')).addClass('active');
        } else if($this.is('.as-list')){
            $(self.$_fcTemplate[0].querySelector('.directory-entry .list')).addClass('active');
        }
        $this.addClass('ui-btn-active');
        $fileViewFormat.controlgroup('refresh');
    });

    $(this.$_fcTemplate[0].querySelector('.file-view-format .as-list')).click(function(){
    });
  },

  close:function () {

  },

  _openExplorer:function (root, success, fail) {
      console.log('_openExplorer');
    this._browseDirectory(root, success, fail);
    $.mobile.changePage(this.$_fcTemplate);
  },

  _browseDirectory: function(entry, success, fail){
      console.log('_browseDirectory');
      var $eb = this._createEntryBrowser(entry);
  },

  _fillEntries:function ($entryBrowser) {
      console.log('_fillEntries');
      var entry = $entryBrowser.data('directory-entry');
      console.log($entryBrowser.length);
      console.log(typeof entry);
      var directoryReader = entry.createReader();
      var self = this;
      directoryReader.readEntries(function(entries){
          console.log('entries:' + entries.length)
          if(entries && entries.length > 0){
              for (var i = 0; i < entries.length; i++) {
                  var entry = entries[i];
                  self._appendEntryTo(entry, $entryBrowser);
              }
          }
          self.$_fcTemplate[0].getElementsByClassName('directory-entry')[0].style.display = 'none';
          $entryBrowser.show();
      }, function(e){
          console.log('failed to read entries!')
          //fail(e);
      });
  },

  _createEntryBrowser:function (entry) {
      console.log('_createEntryBrowser');
      var $eb = this.$_entryBrowserTpl.clone();
    $eb.removeClass('entry-browser-template').addClass('directory-entry');
    $eb[0].getElementsByClassName('entry-name')[0].textContent = entry.name;
    $eb.data('directory-entry', entry);
    $eb[0].getElementsByClassName('file-view-container')[0].innerHTML = '';
      $eb.insertAfter(this.$_entryBrowserTpl);
      this._fillEntries($eb);
    return $eb;
  },

  _appendEntryTo:function(entry, $entryBrowser){
      console.log('_appendEntryTo');
      var self = this;
    // list {
    var $listItem = $(this.$_entryBrowserTpl[0].querySelector('.file-view.list .entry-wrapper').cloneNode(true));
      $entryBrowser[0].querySelector('.file-view.list .file-view-container').appendChild($listItem[0]);
    $listItem[0].getElementsByClassName('entry')[0].textContent = entry.name;
    if(entry.isDirectory){
      $listItem.prepend($(this.$_entryBrowserTpl[0].querySelector('.file-view.list .entry img')));
        $($listItem[0].getElementsByClassName('entry')[0]).addClass('folder').click(function(e){
        self._browseDirectory(entry);
      });
    }
    $($listItem[0].getElementsByClassName('entry')[0]).data('entry', entry);
    // } list

    // Tile {
    var tile = this.$_entryBrowserTpl[0].querySelector('.file-view-container.tiles .entry-wrapper').cloneNode(true);
      $entryBrowser[0].querySelector('.file-view-container.tiles').appendChild(tile);
    tile.getElementsByClassName('entry')[0].textContent = entry.name;
    if(entry.isDirectory){
      $(tile.getElementsByClassName('entry')[0]).addClass('folder').click(function(e){
        self._browseDirectory(entry);
      });
      
    }
    $(tile.getElementsByClassName('entry')[0]).data('entry', entry);
    // } tile

  }
}
