UIComponent._registryWall = function (params, $template)
{
  try {
    params.$template = $template;
    var $feed = $template.find('.social-feed');
    var ins = new ActivityFeed($feed, params);

    ins.renderActions = function (actions, end) {

      var self = this;

      if (actions.length) {

        var html = '';
        for (var i = 0; i < actions.length; i++) {
          var action = actions[i];
          html += action.html;
        }
        var $ul = $('<ul />').html(html);
        self.$wall.append($ul.children());

        if (end) {
          self.$viewMore.hide();
        } else {
          self.$viewMore.show();
        }

      } else {

        self.$viewMore.hide();

        setTimeout(function () {
          UIComponent.helper.showMessage(self.params.noItemsMessage);
        }, 100);

      }

      if (this.timeline_view) {
        this.separator.scan();
      }

      self.$wall.find('.photoviewer').not('.initialized').addClass('initialized').each(function (i, e){
        $(e).closest('.feedItem').find('a.photoviewer').photoSwipe({ enableMouseWheel:false, enableKeyboard:false, enableComment: false  });
      });

    };


  } catch (e){}

  /**
   * Create objects in window
   */
  if (!window._wall_keys){
    window._wall_keys = [];
  }
  var n = window._wall_keys.length;
  window._wall_keys[n] = '_wall_'+ n;
  window[window._wall_keys[n]] = ins;
  window.wall = ins;

  $template.find('.composeLink').data('key', window._wall_keys[n]);

};